import type { Version } from '../models/Version';
import type { CancelablePromise } from '../core/CancelablePromise';
export declare class VersionService {
    /**
     * Version
     * API and data versions.
     *
     * API version follows [Semantic Versioning 2.0.0 Schema](https://semver.org/spec/v2.0.0.html).
     * Data version is UTC timestamp in `yyyy-MM-dd'T'HH:mm:ss` format.
     * @returns Version OK
     * @throws ApiError
     */
    static version(): CancelablePromise<Version>;
}
