"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VersionService = void 0;
const OpenAPI_1 = require("../core/OpenAPI");
const request_1 = require("../core/request");
class VersionService {
    /**
     * Version
     * API and data versions.
     *
     * API version follows [Semantic Versioning 2.0.0 Schema](https://semver.org/spec/v2.0.0.html).
     * Data version is UTC timestamp in `yyyy-MM-dd'T'HH:mm:ss` format.
     * @returns Version OK
     * @throws ApiError
     */
    static version() {
        return (0, request_1.request)(OpenAPI_1.OpenAPI, {
            method: 'GET',
            url: '/version',
            errors: {
                400: `Bad request`,
            },
        });
    }
}
exports.VersionService = VersionService;
