"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MappingLogic = void 0;
const mcode = require("./mcodeextractor");
/**
 * A class that describes the mapping logic of the matching service.
 */
class MappingLogic {
    /**
     * Constructor.
     * @param patientBundle
     */
    constructor(patientBundle) {
        this.extractedMcode = new mcode.mCODEextractor(patientBundle);
    }
    /**
     * Extracted mCODE getters.
     */
    getExtractedPrimaryCancerConditions() {
        return this.extractedMcode.getPrimaryCancerConditions();
    }
    getExtractedSecondaryCancerConditions() {
        return this.extractedMcode.getSecondaryCancerConditions();
    }
    getExtractedTNMclinicalStageGroup() {
        return this.extractedMcode.getTNMclinicalStageGroup();
    }
    getExtractedTNMpathologicalStageGroup() {
        return this.extractedMcode.getTNMpathologicalStageGroup();
    }
    getExtractedBirthDate() {
        return this.extractedMcode.getBirthDate();
    }
    getExtractedTumorMarkers() {
        return this.extractedMcode.getTumorMarkers();
    }
    getExtractedCancerGeneticVariants() {
        return this.extractedMcode.getCancerGeneticVariants();
    }
    getExtractedCancerRelatedRadiationProcedures() {
        return this.extractedMcode.getCancerRelatedRadiationProcedures();
    }
    getExtractedCancerRelatedSurgicalProcedures() {
        return this.extractedMcode.getCancerRelatedSurgicalProcedures();
    }
    getExtractedCancerRelatedMedicationStatements() {
        return this.extractedMcode.getCancerRelatedMedicationStatements();
    }
    getExtractedEcogPerformanceStatus() {
        return this.extractedMcode.getEcogPerformanceStatus();
    }
    getExtractedKarnofskyPerformanceStatus() {
        return this.extractedMcode.getKarnofskyPerformanceStatus();
    }
}
exports.MappingLogic = MappingLogic;
